# std::basic_streambuf< CharT, Traits > Class Template Reference

The actual work of input and output (interface). More...

Inheritance diagram for std::basic_streambuf< CharT, Traits >:

[legend]
Collaboration diagram for std::basic_streambuf< CharT, Traits >:

[legend]
List of all members.

## [NOHEADER]

virtual | ~basic_streambuf ()
| Destructor deallocates no buffer space.
locale | pubimbue (const locale &__loc)
| Entry point for imbue().
locale | getloc () const
| Locale access.
char_type * | M_in_beg
| Entry point for imbue().
char_type * | M_in_cur
| Entry point for imbue().
char_type * | M_in_end
| Entry point for imbue().
char_type * | M_out_beg
| Entry point for imbue().
char_type * | M_out_cur
| Entry point for imbue().
char_type * | M_out_end
| Entry point for imbue().
locale | M_buf_locale
| Entry point for imbue().

## Public Types

typedef CharT | char_type
typedef Traits | traits_type
typedef traits_type::int_type | int_type
typedef traits_type::pos_type | pos_type
typedef traits_type::off_type | off_type

## Public Member Functions

streamsize | in_avail ()
| Looking ahead into the stream.
int_type | snextc ()
| Getting the next character.
int_type | sbumpc ()
| Getting the next character.
int_type | sgetc ()
| Getting the next character.
streamsize | sgetn (char_type *s, streamsize n)
| Entry point for xsgetn.
int_type | sputbackc (char_type c)
| Pushing characters back into the input stream.
int_type | sungetc ()
| Moving backwards in the input stream.
int_type | sputc (char_type c)
| Entry point for all single-character output functions.
streamsize | sputn (const char_type *s, streamsize n)
| Entry point for all single-character output functions.
streambuf_type * | pubsetbuf (char_type *s, streamsize n)
| Entry points for derived buffer functions.
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
pos_type | pubseekpos (pos_type sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Entry points for derived buffer functions.
int | pubsync ()
| Entry points for derived buffer functions.

## Protected Member Functions

| basic_streambuf ()
| Base constructor.
void | gbump (int n)
| Moving the read position.
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
| Setting the three read area pointers.
void | pbump (int n)
| Moving the write position.
void | setp (char_type *__pbeg, char_type *__pend)
| Setting the three write area pointers.
virtual void | imbue (const locale &)
| Changes translations.
virtual basic_streambuf< char_type, Traits > * | setbuf (char_type *, streamsize)
| Maniuplates the buffer.
virtual pos_type | seekoff (off_type, ios_base::seekdir, ios_base::openmode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual pos_type | seekpos (pos_type, ios_base::openmode=ios_base::in|ios_base::out)
| Alters the stream positions.
virtual int | sync ()
| Synchronizes the buffer arrays with the controlled sequences.
virtual streamsize | showmanyc ()
| Investigating the data available.
virtual streamsize | xsgetn (char_type *s, streamsize n)
| Multiple character extraction.
virtual int_type | underflow ()
| Fetches more data from the controlled sequence.
virtual int_type | uflow ()
| Fetches more data from the controlled sequence.
virtual int_type | pbackfail (int_type=traits_type::eof())
| Tries to back up the input sequence.
virtual streamsize | xsputn (const char_type *s, streamsize n)
| Multiple character insertion.
virtual int_type | overflow (int_type=traits_type::eof())
| Consumes data from the buffer; writes to the controlled sequence.
char_type * | eback () const
| Access to the get area.
char_type * | gptr () const
| Access to the get area.
char_type * | egptr () const
| Access to the get area.
char_type * | pbase () const
| Access to the put area.
char_type * | pptr () const
| Access to the put area.
char_type * | epptr () const
| Access to the put area.

## Detailed Description

### template<typename CharT, typename Traits>
class std::basic_streambuf< CharT, Traits >

The actual work of input and output (interface).

This is a base class. Derived stream buffers each control a pair of character sequences: one for input, and one for output.

Section [27.5.1] of the standard describes the requirements and behavior of stream buffer classes. That section (three paragraphs) is reproduced here, for simplicity and accuracy.

1. Stream buffers can impose various constraints on the sequences they control. Some constraints are:
   - The controlled input sequence can be not readable.
   - The controlled output sequence can be not writable.
   - The controlled sequences can be associated with the contents of other representations for character sequences, such as external files.
   - The controlled sequences can support operations directly to or from associated sequences.
   - The controlled sequences can impose limitations on how the program can read characters from a sequence, write characters to a sequence, put characters back into an input sequence, or alter the stream position.
2. Each sequence is characterized by three pointers which, if non-null, all point into the same `charT` array object. The array object represents, at any moment, a (sub)sequence of characters from the sequence. Operations performed on a sequence alter the values stored in these pointers, perform reads and writes directly to or from associated sequences, and alter "the stream position" and conversion state as needed to maintain this subsequence relationship. The three pointers are:
   - the beginning pointer, or lowest element address in the array (called xbeg here);
   - the next pointer, or next element address that is a current candidate for reading or writing (called xnext here);
   - the end pointer, or first element address beyond the end of the array (called xend here).
3. The following semantic constraints shall always apply for any set of three pointers for a sequence, using the pointer names given immediately above:
   - If xnext is not a null pointer, then xbeg and xend shall also be non-null pointers into the same `charT` array, as described above; otherwise, xbeg and xend shall also be null.
   - If xnext is not a null pointer and xnext < xend for an output sequence, then a write position is available. In this case, *xnext shall be assignable as the next element to write (to put, or to store a character value, into the sequence).
   - If xnext is not a null pointer and xbeg < xnext for an input sequence, then a putback position is available. In this case, xnext[-1] shall have a defined value and is the next (preceding) element to store a character that is put back into the input sequence.
   - If xnext is not a null pointer and xnext< xend for an input sequence, then a read position is available. In this case, *xnext shall have a defined value and is the next element to read (to get, or to obtain a character value, from the sequence).

Definition at line 123 of file streambuf.

## Member Typedef Documentation

template<typename CharT, typename Traits>
typedef CharT std::basic_streambuf< CharT, Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in __gnu_cxx::stdio_filebuf< CharT, Traits >, std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 132 of file streambuf.

template<typename CharT, typename Traits>
typedef traits_type::int_type std::basic_streambuf< CharT, Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in __gnu_cxx::stdio_filebuf< CharT, Traits >, std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 134 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsgetn(), and std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
typedef traits_type::off_type std::basic_streambuf< CharT, Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in __gnu_cxx::stdio_filebuf< CharT, Traits >, std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 136 of file streambuf.

template<typename CharT, typename Traits>
typedef traits_type::pos_type std::basic_streambuf< CharT, Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in __gnu_cxx::stdio_filebuf< CharT, Traits >, std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 135 of file streambuf.

template<typename CharT, typename Traits>
typedef Traits std::basic_streambuf< CharT, Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented in __gnu_cxx::stdio_filebuf< CharT, Traits >, std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 133 of file streambuf.

## Constructor & Destructor Documentation

template<typename CharT, typename Traits>
virtual std::basic_streambuf< CharT, Traits >::~basic_streambuf | ( |  | ) | `[inline, virtual]`

| Destructor deallocates no buffer space. Definition at line 186 of file streambuf.

template<typename CharT, typename Traits>
std::basic_streambuf< CharT, Traits >::basic_streambuf | ( |  | ) | `[inline, protected]`

Base constructor.

Only called from derived constructors, and sets up all the buffer data to zero, including the pointers described in the basic_streambuf class description. Note that, as a result,

- the class starts with no read nor write positions available,
- this is not an error

Definition at line 433 of file streambuf.

## Member Function Documentation

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::eback | ( |  | ) | const`[inline, protected]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 452 of file streambuf.

Referenced by std::basic_filebuf< CharT, Traits >::imbue(), std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::pbackfail(), std::basic_filebuf< CharT, Traits >::pbackfail(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputbackc(), and std::basic_filebuf< CharT, Traits >::underflow().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::egptr | ( |  | ) | const`[inline, protected]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 458 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::in_avail(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sbumpc(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sgetc(), std::basic_filebuf< CharT, Traits >::showmanyc(), std::basic_stringbuf< CharT, Traits, Alloc >::str(), std::basic_stringbuf< CharT, Traits, Alloc >::underflow(), std::basic_filebuf< CharT, Traits >::underflow(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::epptr | ( |  | ) | const`[inline, protected]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 505 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputc(), and std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::gbump | ( | int | n | ) | `[inline, protected]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 468 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 215 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::gptr | ( |  | ) | const`[inline, protected]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 455 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::in_avail(), std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::pbackfail(), std::basic_filebuf< CharT, Traits >::pbackfail(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), std::basic_filebuf< CharT, Traits >::showmanyc(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputbackc(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sungetc(), std::basic_stringbuf< CharT, Traits, Alloc >::underflow(), std::basic_filebuf< CharT, Traits >::underflow(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
virtual void std::basic_streambuf< CharT, Traits >::imbue | ( | const locale & |  | ) | `[inline, protected, virtual]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 546 of file streambuf.

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::in_avail | ( |  | ) | `[inline]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 255 of file streambuf.

template<typename CharT, typename Traits>
virtual int_type std::basic_streambuf< CharT, Traits >::overflow | ( | int_type | = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definiton of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 737 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
virtual int_type std::basic_streambuf< CharT, Traits >::pbackfail | ( | int_type | = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 694 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::pbase | ( |  | ) | const`[inline, protected]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 499 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_filebuf< CharT, Traits >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_stringbuf< CharT, Traits, Alloc >::seekpos(), and std::basic_filebuf< CharT, Traits >::sync().

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::pbump | ( | int | n | ) | `[inline, protected]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 515 of file streambuf.

Referenced by std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::pptr | ( |  | ) | const`[inline, protected]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 502 of file streambuf.

Referenced by std::basic_stringbuf< CharT, Traits, Alloc >::overflow(), std::basic_filebuf< CharT, Traits >::overflow(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::sputc(), std::basic_stringbuf< CharT, Traits, Alloc >::str(), std::basic_filebuf< CharT, Traits >::sync(), and std::basic_streambuf< CharT, Traits >::xsputn().

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 198 of file streambuf.

template<typename CharT, typename Traits>
pos_type std::basic_streambuf< CharT, Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 232 of file streambuf.

template<typename CharT, typename Traits>
pos_type std::basic_streambuf< CharT, Traits >::pubseekpos | ( | pos_type | sp,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 237 of file streambuf.

template<typename CharT, typename Traits>
streambuf_type* std::basic_streambuf< CharT, Traits >::pubsetbuf | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 228 of file streambuf.

template<typename CharT, typename Traits>
int std::basic_streambuf< CharT, Traits >::pubsync | ( |  | ) | `[inline]`

| Entry points for derived buffer functions. The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged. Definition at line 242 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sbumpc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 287 of file streambuf.

Referenced by std::operator>>().

template<typename CharT, typename Traits>
virtual pos_type std::basic_streambuf< CharT, Traits >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out`
| ) | `[inline, protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 572 of file streambuf.

template<typename CharT, typename Traits>
virtual pos_type std::basic_streambuf< CharT, Traits >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out`
| ) | `[inline, protected, virtual]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 584 of file streambuf.

template<typename CharT, typename Traits>
virtual basic_streambuf<char_type,Traits>* std::basic_streambuf< CharT, Traits >::setbuf | ( | char_type * | ,
|  | streamsize |
| ) | `[inline, protected, virtual]`

Maniuplates the buffer.

Each derived class provides its own appropriate behavior. See the next-to-last paragraph of http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more on this function.

Note:
  Base class version does nothing, returns `this`.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 561 of file streambuf.

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend
| ) | `[inline, protected]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 479 of file streambuf.

template<typename CharT, typename Traits>
void std::basic_streambuf< CharT, Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend
| ) | `[inline, protected]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 525 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sgetc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 309 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::snextc().

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::sgetn | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 328 of file streambuf.

template<typename CharT, typename Traits>
virtual streamsize std::basic_streambuf< CharT, Traits >::showmanyc | ( |  | ) | `[inline, protected, virtual]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 619 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::in_avail().

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::snextc | ( |  | ) | `[inline]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 269 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sputbackc | ( | char_type | c | ) | `[inline]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 342 of file streambuf.

Referenced by std::operator>>().

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sputc | ( | char_type | c | ) | `[inline]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 394 of file streambuf.

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::sputn | ( | const char_type * | s,
|  | streamsize | n
| ) | `[inline]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 420 of file streambuf.

template<typename CharT, typename Traits>
int_type std::basic_streambuf< CharT, Traits >::sungetc | ( |  | ) | `[inline]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 367 of file streambuf.

template<typename CharT, typename Traits>
virtual int std::basic_streambuf< CharT, Traits >::sync | ( | void |  | ) | `[inline, protected, virtual]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 597 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::pubsync().

template<typename CharT, typename Traits>
virtual int_type std::basic_streambuf< CharT, Traits >::uflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Definition at line 670 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::sbumpc(), and std::basic_streambuf< CharT, Traits >::xsgetn().

template<typename CharT, typename Traits>
virtual int_type std::basic_streambuf< CharT, Traits >::underflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definiton of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_stringbuf< CharT, Traits, Alloc >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 657 of file streambuf.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::sgetc().

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::xsgetn | ( | char_type * | s,
|  | streamsize | n
| ) | `[protected, virtual]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 45 of file streambuf.tcc.

References std::basic_streambuf< CharT, Traits >::egptr(), std::basic_streambuf< CharT, Traits >::gbump(), std::basic_streambuf< CharT, Traits >::gptr(), std::basic_streambuf< CharT, Traits >::int_type, std::min(), std::streamsize, and std::basic_streambuf< CharT, Traits >::uflow().

template<typename CharT, typename Traits>
streamsize std::basic_streambuf< CharT, Traits >::xsputn | ( | const char_type * | s,
|  | streamsize | n
| ) | `[protected, virtual]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< CharT, Traits >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< CharT, enc_char_traits< CharT > >.

Definition at line 79 of file streambuf.tcc.

References std::basic_streambuf< CharT, Traits >::epptr(), std::basic_streambuf< CharT, Traits >::int_type, std::min(), std::basic_streambuf< CharT, Traits >::overflow(), std::basic_streambuf< CharT, Traits >::pbump(), std::basic_streambuf< CharT, Traits >::pptr(), and std::streamsize.

## Member Data Documentation

template<typename CharT, typename Traits>
locale std::basic_streambuf< CharT, Traits >::M_buf_locale `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 181 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_beg `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 169 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_cur `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 170 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_in_end `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 171 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_beg `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 172 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_cur `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 173 of file streambuf.

template<typename CharT, typename Traits>
char_type* std::basic_streambuf< CharT, Traits >::M_out_end `[protected]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 174 of file streambuf.

The documentation for this class was generated from the following files:

- streambuf
- streambuf.tcc